---
name: Pull request
about: Create a pull request and contribute to the project
title: ''
labels: ''
assignees: ''

---

**Description of the pull request**
A clear and concise description of your changes.

**Motivation and context**
Why is this change required? What problem does it solve? If it fixes an open issue, please link to the issue here.

**How has the change been tested?**
Describe in detail how you tested your changes. Include your testing environment, tests ran to see how your changes affects other areas of the code, etc.

**Screenshots**
If applicable, add screenshots to help explain your changes.

**Types of changes**
What types of changes does your code introduce? Put an `x` in all the boxes that apply:
- [ ] Bug fix (non-breaking change which fixes an issue)
- [ ] New feature (non-breaking change which adds functionality)
- [ ] Breaking change (fix or feature that would cause existing functionality to not work as expected)

**Checklist**
Go over all the following points, and put an `x` in all the boxes that apply. If you're unsure about any of these, don't hesitate to ask.
- [ ] My code follows the code style of this project.
- [ ] My change requires a change to the documentation.
- [ ] I have updated the documentation accordingly.
