//
//  KlarnaNativePaymentViewFactory.m
//  flutter_klarna_inapp_sdk
//
//  Created by ZhangYu on 2021/9/14.
//

#import "KlarnaNativePaymentViewFactory.h"
#import "KlarnaNativePaymentController.h"

@implementation KlarnaNativePaymentViewFactory {
    NSObject<FlutterBinaryMessenger>* _messenger;
}

- (instancetype)initWithMessenger:(NSObject<FlutterBinaryMessenger> *)messenger {
    self = [super init];
    if (self) {
        _messenger = messenger;
    }
    return self;
}

- (nonnull NSObject<FlutterPlatformView> *)createWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id _Nullable)args {
    return [[KlarnaNativePaymentController alloc] initWithFrame:frame viewIdentifier:viewId arguments:args binaryMessenger:_messenger];
}

- (NSObject<FlutterMessageCodec> *)createArgsCodec {
    return FlutterStandardMessageCodec.sharedInstance;
}

@end
